VERSION 5.00
Begin VB.UserControl WLClock 
   BackStyle       =   0  'Transparent
   ClientHeight    =   1590
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1710
   ScaleHeight     =   1590
   ScaleWidth      =   1710
   ToolboxBitmap   =   "WLClock.ctx":0000
   Windowless      =   -1  'True
   Begin VB.Timer tmrTick 
      Interval        =   500
      Left            =   1200
      Top             =   1080
   End
   Begin VB.Line linTic 
      Index           =   0
      X1              =   1200
      X2              =   1320
      Y1              =   240
      Y2              =   120
   End
   Begin VB.Line linSecondHand 
      X1              =   600
      X2              =   1080
      Y1              =   600
      Y2              =   600
   End
   Begin VB.Line linMinuteHand 
      BorderWidth     =   2
      X1              =   960
      X2              =   600
      Y1              =   360
      Y2              =   600
   End
   Begin VB.Line linHourHand 
      BorderWidth     =   3
      X1              =   600
      X2              =   840
      Y1              =   600
      Y2              =   840
   End
   Begin VB.Shape shpClockFace 
      Height          =   1215
      Left            =   0
      Shape           =   2  'Oval
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "WLClock"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

' Proportional hand lengths.
Private Const m_HourHandLength = 0.5
Private Const m_MinuteHandLength = 0.75
Private Const m_SecondHandLength = 0.9

' The center of the clock.
Private m_Cx As Single
Private m_Cy As Single

Private Const PI = 3.14159265

' Position the constituent Line controls
' to show the current time.
Private Sub PositionHands()
Dim X As Single
Dim Y As Single
Dim theta As Single

    ' Position the hour hand.
    theta = PI / 2 - Hour(Now) * (PI * 2 / 12)
    linHourHand.X2 = m_Cx * (1 + m_HourHandLength * Cos(theta))
    linHourHand.Y2 = m_Cy * (1 - m_HourHandLength * Sin(theta))

    ' Position the minute hand.
    theta = PI / 2 - Minute(Now) * (PI * 2 / 60)
    linMinuteHand.X2 = m_Cx * (1 + m_MinuteHandLength * Cos(theta))
    linMinuteHand.Y2 = m_Cy * (1 - m_MinuteHandLength * Sin(theta))

    ' Position the second hand.
    theta = PI / 2 - Second(Now) * (PI * 2 / 60)
    linSecondHand.X2 = m_Cx * (1 + m_SecondHandLength * Cos(theta))
    linSecondHand.Y2 = m_Cy * (1 - m_SecondHandLength * Sin(theta))
End Sub

Private Sub tmrTick_Timer()
Static last_time As Date

    If last_time = Now Then Exit Sub

    last_time = Now
    PositionHands
End Sub


Private Sub UserControl_Initialize()
Dim i As Integer

    ' Load tic mark Line controls.
    For i = 1 To 59
        Load linTic(i)
        linTic(i).Visible = True
    Next i
End Sub

' Position the clock face and tic marks. Put one end
' of the hands at the center of the clock.
Private Sub UserControl_Resize()
Const TIC_R1 = 0.95
Const TIC_R2 = 0.9
Dim i As Integer
Dim tic_r As Single
Dim theta As Single
Dim dtheta As Single
Dim cos_theta As Single
Dim sin_theta As Single

    ' Make the clock face fit the control.
    shpClockFace.Move 0, 0, ScaleWidth, ScaleHeight

    ' Find the center of the clock.
    m_Cx = ScaleWidth / 2
    m_Cy = ScaleHeight / 2

    ' Move one end of the hands to the center.
    linHourHand.X1 = m_Cx
    linHourHand.Y1 = m_Cy
    linMinuteHand.X1 = m_Cx
    linMinuteHand.Y1 = m_Cy
    linSecondHand.X1 = m_Cx
    linSecondHand.Y1 = m_Cy

    ' Position the tic marks.
    theta = PI / 2
    dtheta = 2 * PI / 60
    For i = 0 To 59
        ' Make every 5th tic mark longer.
        If i Mod 5 = 0 Then
            tic_r = TIC_R2
        Else
            tic_r = TIC_R1
        End If

        ' Position the tic mark.
        With linTic(i)
            .X1 = m_Cx * (1 + Cos(theta))
            .Y1 = m_Cx * (1 + Sin(theta))
            .X2 = m_Cx * (1 + tic_r * Cos(theta))
            .Y2 = m_Cx * (1 + tic_r * Sin(theta))
        End With
        theta = theta + dtheta
    Next i

    ' Show the time.
    PositionHands
End Sub
